#ifndef ULISTS_H
#define ULISTS_H
/** \file Definitions for list handling.
*/
/*   
   Copyright  2003-2009 M.Kraemer, D-64291 Darmstadt, Seegartenstr. 32,
                         all rights reserved
   $Log: ulists.h,v $
   Revision 1.2  2015/01/05 18:44:58  kraemer
   *** empty log message ***

   Revision 1.1.1.1  2009/05/06 16:21:41  kraemer


   Revision 1.1.2.2  2009/05/06 14:07:17  kraemer
   doxy

   Revision 1.1.2.1  2008/06/20 16:28:03  kraemer
   *** empty log message ***


*/

#include "utypes.h"

#if defined(AMIGA)
#include <exec/nodes.h>
#include <exec/lists.h>
#define RemNode Remove
#else

struct Node {                                                                   
    struct  Node *ln_Succ;                                                      
    struct  Node *ln_Pred;                                                      
    uint8_t   ln_Type;                                                            
    int8_t    ln_Pri;                                                             
    char    *ln_Name;                                                           
};                                                                              
struct MinNode {                                                                
    struct MinNode *mln_Succ;                                                   
    struct MinNode *mln_Pred;                                                   
};                                                                              

struct List {
    struct  Node *lh_Head;
    struct  Node *lh_Tail;
    struct  Node *lh_TailPred;
    uint8_t   lh_Type;
    uint8_t   l_pad;
};
struct MinList {
    struct MinNode *mlh_Head;
    struct MinNode *mlh_Tail;
    struct MinNode *mlh_TailPred;
};

void NewList( struct List *);
struct Node *RemTail( struct List * );
struct Node *RemHead( struct List * );
struct Node *FindName( struct List *, const char * );
void AddTail( struct List *, struct Node * );
void RemNode( struct Node * );
#endif	
 
struct Node *FindIName( struct List *, const char * );

#endif
